Skip to content
Start here

Get resource change history from an account audit log entry (Version 2)

GET/accounts/{account_id}/logs/audit/{id}/history

Returns the chronological change history for the resource identified by the given audit log entry.

The endpoint first locates the source audit log entry by id (using action_time to narrow the lookup window), derives identifying filters from that entry, and then returns matching audit logs within the since/before window.

The result_info.history_status field indicates the quality of the resource identification used:

  • exact: Resource was identified by the resource URI.
  • approximate: Resource was identified without the resource URI.
  • unavailable: The source audit log entry did not contain enough information to identify the resource; an empty result is returned.
Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
Accepted Permissions (at least one required)
Account Settings WriteAccount Settings Read
Path ParametersExpand Collapse
account_id: string

The unique ID that identifies the account.

id: string

The ID of the audit log to fetch resource history for.

formatuuid
Query ParametersExpand Collapse
action_time: string

RFC3339 timestamp of the source audit log entry’s action time. Used to narrow the source-entry lookup window. Provide the action.time value from the audit log identified by id.

formatdate-time
before: string

Limits the returned results to logs older than the specified date. This can be a date string 2019-04-30 (interpreted in UTC) or an absolute timestamp that conforms to RFC3339.

formatdate
since: string

Limits the returned results to logs newer than the specified date. This can be a date string 2019-04-30 (interpreted in UTC) or an absolute timestamp that conforms to RFC3339.

formatdate
cursor: optional string

The cursor is an opaque token used to paginate through large sets of records. It indicates the position from which to continue when requesting the next set of records. A valid cursor value can be obtained from the cursor object in the result_info structure of a previous response.

direction: optional "desc" or "asc"

Sets sorting order.

One of the following:
"desc"
"asc"
limit: optional number

The number limits the objects to return. The cursor attribute may be used to iterate over the next batch of objects if there are more than the limit.

maximum1000
minimum1
ReturnsExpand Collapse
errors: array of object { message }
message: string
result: array of object { id, account, action, 4 more }
id: optional string

A unique identifier for the audit log entry.

maxLength32
account: optional object { id, name }

Contains account related information.

id: optional string

A unique identifier for the account.

name: optional string

A string that identifies the account name.

action: optional object { description, result, time, type }

Provides information about the action performed.

description: optional string

A short description of the action performed.

result: optional string

The result of the action, indicating success or failure.

time: optional string

A timestamp indicating when the action was logged.

formatdate-time
type: optional string

A short string that describes the action that was performed.

actor: optional object { id, context, email, 4 more }

Provides details about the actor who performed the action.

id: optional string

The ID of the actor who performed the action. If a user performed the action, this will be their User ID.

context: optional "api_key" or "api_token" or "dash" or 2 more
One of the following:
"api_key"
"api_token"
"dash"
"oauth"
"origin_ca_key"
email: optional string

The email of the actor who performed the action.

formatemail
ip_address: optional string

The IP address of the request that performed the action.

token_id: optional string

The API token ID when the actor context is an api_token or oauth.

token_name: optional string

The API token name when the actor context is an api_token or oauth.

type: optional "account" or "cloudflare_admin" or "system" or "user"

The type of actor.

One of the following:
"account"
"cloudflare_admin"
"system"
"user"
raw: optional object { cf_ray_id, method, status_code, 2 more }

Provides raw information about the request and response.

cf_ray_id: optional string

The Cloudflare Ray ID for the request.

method: optional string

The HTTP method of the request.

status_code: optional number

The HTTP response status code returned by the API.

uri: optional string

The URI of the request.

user_agent: optional string

The client’s user agent string sent with the request.

resource: optional object { id, product, request, 3 more }

Provides details about the affected resource.

id: optional string

The unique identifier for the affected resource.

product: optional string

The Cloudflare product associated with the resource.

request: optional unknown
response: optional unknown
scope: optional unknown

The scope of the resource.

type: optional string

The type of the resource.

zone: optional object { id, name }

Provides details about the zone affected by the action.

id: optional string

A string that identifies the zone id.

name: optional string

A string that identifies the zone name.

result_info: object { count, history_status, cursor }

Provides information about the result of the request, including count, cursor, and identification quality.

count: number

The number of records returned in the response.

history_status: "exact" or "approximate" or "unavailable"

Indicates the quality of the resource identification used to derive the history.

  • exact: Resource was identified by the resource URI.
  • approximate: Resource was identified without the resource URI.
  • unavailable: The source audit log entry did not contain enough information to identify the resource; result is empty.
One of the following:
"exact"
"approximate"
"unavailable"
cursor: optional string

The cursor token used for pagination.

success: true

Indicates whether the API call was successful

Get resource change history from an account audit log entry (Version 2)

curl https://api.cloudflare.com/client/v4/accounts/$ACCOUNT_ID/logs/audit/$ID/history \
    -H "Authorization: Bearer $CLOUDFLARE_API_TOKEN"
{
  "errors": [
    {
      "message": "message"
    }
  ],
  "result": [
    {
      "id": "023e105f4ecef8ad9ca31a8372d0c353",
      "account": {
        "id": "4bb334f7c94c4a29a045f03944f072e5",
        "name": "Example Account"
      },
      "action": {
        "description": "Add Member",
        "result": "success",
        "time": "2024-04-26T17:31:07Z",
        "type": "create"
      },
      "actor": {
        "id": "f6b5de0326bb5182b8a4840ee01ec774",
        "context": "dash",
        "email": "alice@example.com",
        "ip_address": "198.41.129.166",
        "token_id": "token_id",
        "token_name": "token_name",
        "type": "user"
      },
      "raw": {
        "cf_ray_id": "8e9b1c60ef9e1c9a",
        "method": "POST",
        "status_code": 200,
        "uri": "/accounts/4bb334f7c94c4a29a045f03944f072e5/members",
        "user_agent": "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) Safari/605.1.15"
      },
      "resource": {
        "id": "id",
        "product": "members",
        "request": {},
        "response": {},
        "scope": {},
        "type": "type"
      },
      "zone": {
        "id": "id",
        "name": "example.com"
      }
    }
  ],
  "result_info": {
    "count": 1,
    "history_status": "exact",
    "cursor": "ASqdKd7dKgxh-aZ8bm0mZos1BtW4BdEqifCzNkEeGRzi_5SN_-362Y8sF-C1TRn60_6rd3z2dIajf9EAPyQ_NmIeAMkacmaJPXipqvP7PLU4t72wyqBeJfjmjdE="
  },
  "success": true
}
Returns Examples
{
  "errors": [
    {
      "message": "message"
    }
  ],
  "result": [
    {
      "id": "023e105f4ecef8ad9ca31a8372d0c353",
      "account": {
        "id": "4bb334f7c94c4a29a045f03944f072e5",
        "name": "Example Account"
      },
      "action": {
        "description": "Add Member",
        "result": "success",
        "time": "2024-04-26T17:31:07Z",
        "type": "create"
      },
      "actor": {
        "id": "f6b5de0326bb5182b8a4840ee01ec774",
        "context": "dash",
        "email": "alice@example.com",
        "ip_address": "198.41.129.166",
        "token_id": "token_id",
        "token_name": "token_name",
        "type": "user"
      },
      "raw": {
        "cf_ray_id": "8e9b1c60ef9e1c9a",
        "method": "POST",
        "status_code": 200,
        "uri": "/accounts/4bb334f7c94c4a29a045f03944f072e5/members",
        "user_agent": "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) Safari/605.1.15"
      },
      "resource": {
        "id": "id",
        "product": "members",
        "request": {},
        "response": {},
        "scope": {},
        "type": "type"
      },
      "zone": {
        "id": "id",
        "name": "example.com"
      }
    }
  ],
  "result_info": {
    "count": 1,
    "history_status": "exact",
    "cursor": "ASqdKd7dKgxh-aZ8bm0mZos1BtW4BdEqifCzNkEeGRzi_5SN_-362Y8sF-C1TRn60_6rd3z2dIajf9EAPyQ_NmIeAMkacmaJPXipqvP7PLU4t72wyqBeJfjmjdE="
  },
  "success": true
}